/*
 * Copyright 2015 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#pragma once

#include <ox/std/string.hpp>
#include <ox/std/types.hpp>

#include "fieldcounter.hpp"
#include "optype.hpp"

namespace ox {

struct TypeNameCatcher {

	const char *name = "";

	constexpr TypeNameCatcher() noexcept = default;

	template<typename T = std::nullptr_t>
	constexpr void setTypeInfo(const char *n = T::TypeName, int = 0) noexcept {
		this->name = n;
	}

	template<typename T>
	constexpr Error field(const char*, T*, std::size_t) noexcept {
		return OxError(0);
	}

	template<typename T>
	constexpr Error field(const char*, T) noexcept {
		return OxError(0);
	}

	static constexpr auto opType() noexcept {
		return OpType::WriteDefinition;
	}

};

template<typename T>
constexpr const char *getModelTypeName() noexcept {
	T t;
	TypeNameCatcher nc;
	oxIgnoreError(model(&nc, &t));
	return nc.name;
}

template<typename T>
constexpr const char *getModelTypeName(T *val) noexcept {
	TypeNameCatcher nc;
	oxIgnoreError(model(&nc, val));
	return nc.name;
}

}
