/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include <algorithm>

#include "task.hpp"

namespace nostalgia::studio {

void TaskRunner::update(core::Context *ctx) noexcept {
	oxIgnoreError(m_tasks.erase(std::remove_if(m_tasks.begin(), m_tasks.end(), [&](auto &t) {
		return t->update(ctx) == TaskState::Done;
	})));
}

void TaskRunner::add(Task *task) noexcept {
	m_tasks.emplace_back(task);
}

}
