/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#pragma once

#include <ox/std/memory.hpp>
#include <ox/std/string.hpp>

#include <nostalgia/core/context.hpp>

namespace nostalgia {

class ProjectTreeModel {
	private:
		class ProjectExplorer *m_explorer = nullptr;
		ProjectTreeModel *m_parent = nullptr;
		ox::String m_name;
		ox::Vector<ox::UniquePtr<ProjectTreeModel>> m_children;
	public:
		explicit ProjectTreeModel(class ProjectExplorer *explorer, const ox::String &name,
		                          ProjectTreeModel *parent = nullptr) noexcept;

		ProjectTreeModel(ProjectTreeModel &&other) noexcept;

		void draw(core::Context *ctx) noexcept;

		void setChildren(ox::Vector<ox::UniquePtr<ProjectTreeModel>> children) noexcept;

	private:
		[[nodiscard]]
		ox::String fullPath() noexcept;
};

}